#!/usr/bin/env bash
###############################################################################
#
# Bash Remediation Script for Standard System Security Profile for openEuler 22.03 LTS
#
# Profile Description:
# This profile contains rules to ensure standard security baseline
# of an openEuler system. Regardless of your system's workload
# all of these checks should pass.
#
# Profile ID:  standard
# Benchmark ID:  OPENEULER_2203_LTS
# Benchmark Version:  0.1.49
# XCCDF Version:  1.1
#
# This file was generated by OpenSCAP 1.3.6 using:
# $ oscap xccdf generate fix --profile standard --fix-type bash xccdf-file.xml
#
# This Bash Remediation Script is generated from an OpenSCAP profile without preliminary evaluation.
# It attempts to fix every selected rule, even if the system is already compliant.
#
# How to apply this Bash Remediation Script:
# $ sudo ./remediation-script.sh
#
###############################################################################

###############################################################################
# BEGIN fix (1 / 76) for 'grub2_nosmap_argument_absent'
###############################################################################
(>&2 echo "Remediating rule 1/76: 'grub2_nosmap_argument_absent'")
(>&2 echo "FIX FOR THIS RULE 'grub2_nosmap_argument_absent' IS MISSING!")

# END fix for 'grub2_nosmap_argument_absent'

###############################################################################
# BEGIN fix (2 / 76) for 'grub2_nosmep_argument_absent'
###############################################################################
(>&2 echo "Remediating rule 2/76: 'grub2_nosmep_argument_absent'")
(>&2 echo "FIX FOR THIS RULE 'grub2_nosmep_argument_absent' IS MISSING!")

# END fix for 'grub2_nosmep_argument_absent'

###############################################################################
# BEGIN fix (3 / 76) for 'grub2_uefi_password'
###############################################################################
(>&2 echo "Remediating rule 3/76: 'grub2_uefi_password'")
(>&2 echo "FIX FOR THIS RULE 'grub2_uefi_password' IS MISSING!")

# END fix for 'grub2_uefi_password'

###############################################################################
# BEGIN fix (4 / 76) for 'verify_owner_password'
###############################################################################
(>&2 echo "Remediating rule 4/76: 'verify_owner_password'")
(>&2 echo "FIX FOR THIS RULE 'verify_owner_password' IS MISSING!")

# END fix for 'verify_owner_password'

###############################################################################
# BEGIN fix (5 / 76) for 'no_name_contained_in_password'
###############################################################################
(>&2 echo "Remediating rule 5/76: 'no_name_contained_in_password'")
(>&2 echo "FIX FOR THIS RULE 'no_name_contained_in_password' IS MISSING!")

# END fix for 'no_name_contained_in_password'

###############################################################################
# BEGIN fix (6 / 76) for 'accounts_password_pam_dcredit'
###############################################################################
(>&2 echo "Remediating rule 6/76: 'accounts_password_pam_dcredit'")
(>&2 echo "FIX FOR THIS RULE 'accounts_password_pam_dcredit' IS MISSING!")

# END fix for 'accounts_password_pam_dcredit'

###############################################################################
# BEGIN fix (7 / 76) for 'accounts_password_pam_minclass'
###############################################################################
(>&2 echo "Remediating rule 7/76: 'accounts_password_pam_minclass'")
(>&2 echo "FIX FOR THIS RULE 'accounts_password_pam_minclass' IS MISSING!")

# END fix for 'accounts_password_pam_minclass'

###############################################################################
# BEGIN fix (8 / 76) for 'accounts_password_pam_ucredit'
###############################################################################
(>&2 echo "Remediating rule 8/76: 'accounts_password_pam_ucredit'")
(>&2 echo "FIX FOR THIS RULE 'accounts_password_pam_ucredit' IS MISSING!")

# END fix for 'accounts_password_pam_ucredit'

###############################################################################
# BEGIN fix (9 / 76) for 'accounts_password_pam_minlen'
###############################################################################
(>&2 echo "Remediating rule 9/76: 'accounts_password_pam_minlen'")
(>&2 echo "FIX FOR THIS RULE 'accounts_password_pam_minlen' IS MISSING!")

# END fix for 'accounts_password_pam_minlen'

###############################################################################
# BEGIN fix (10 / 76) for 'accounts_password_pam_ocredit'
###############################################################################
(>&2 echo "Remediating rule 10/76: 'accounts_password_pam_ocredit'")
(>&2 echo "FIX FOR THIS RULE 'accounts_password_pam_ocredit' IS MISSING!")

# END fix for 'accounts_password_pam_ocredit'

###############################################################################
# BEGIN fix (11 / 76) for 'accounts_password_pam_retry'
###############################################################################
(>&2 echo "Remediating rule 11/76: 'accounts_password_pam_retry'")
(>&2 echo "FIX FOR THIS RULE 'accounts_password_pam_retry' IS MISSING!")

# END fix for 'accounts_password_pam_retry'

###############################################################################
# BEGIN fix (12 / 76) for 'accounts_password_pam_lcredit'
###############################################################################
(>&2 echo "Remediating rule 12/76: 'accounts_password_pam_lcredit'")
(>&2 echo "FIX FOR THIS RULE 'accounts_password_pam_lcredit' IS MISSING!")

# END fix for 'accounts_password_pam_lcredit'

###############################################################################
# BEGIN fix (13 / 76) for 'accounts_password_pam_dictcheck'
###############################################################################
(>&2 echo "Remediating rule 13/76: 'accounts_password_pam_dictcheck'")
(>&2 echo "FIX FOR THIS RULE 'accounts_password_pam_dictcheck' IS MISSING!")

# END fix for 'accounts_password_pam_dictcheck'

###############################################################################
# BEGIN fix (14 / 76) for 'accounts_passwords_pam_faillock_deny_root'
###############################################################################
(>&2 echo "Remediating rule 14/76: 'accounts_passwords_pam_faillock_deny_root'")
(>&2 echo "FIX FOR THIS RULE 'accounts_passwords_pam_faillock_deny_root' IS MISSING!")

# END fix for 'accounts_passwords_pam_faillock_deny_root'

###############################################################################
# BEGIN fix (15 / 76) for 'accounts_passwords_pam_faillock_unlock_time'
###############################################################################
(>&2 echo "Remediating rule 15/76: 'accounts_passwords_pam_faillock_unlock_time'")
(>&2 echo "FIX FOR THIS RULE 'accounts_passwords_pam_faillock_unlock_time' IS MISSING!")

# END fix for 'accounts_passwords_pam_faillock_unlock_time'

###############################################################################
# BEGIN fix (16 / 76) for 'accounts_passwords_pam_faillock_deny'
###############################################################################
(>&2 echo "Remediating rule 16/76: 'accounts_passwords_pam_faillock_deny'")
(>&2 echo "FIX FOR THIS RULE 'accounts_passwords_pam_faillock_deny' IS MISSING!")

# END fix for 'accounts_passwords_pam_faillock_deny'

###############################################################################
# BEGIN fix (17 / 76) for 'accounts_password_pam_unix_remember'
###############################################################################
(>&2 echo "Remediating rule 17/76: 'accounts_password_pam_unix_remember'")
(>&2 echo "FIX FOR THIS RULE 'accounts_password_pam_unix_remember' IS MISSING!")

# END fix for 'accounts_password_pam_unix_remember'

###############################################################################
# BEGIN fix (18 / 76) for 'set_password_hashing_algorithm_systemauth'
###############################################################################
(>&2 echo "Remediating rule 18/76: 'set_password_hashing_algorithm_systemauth'")
(>&2 echo "FIX FOR THIS RULE 'set_password_hashing_algorithm_systemauth' IS MISSING!")

# END fix for 'set_password_hashing_algorithm_systemauth'

###############################################################################
# BEGIN fix (19 / 76) for 'accounts_are_necessary'
###############################################################################
(>&2 echo "Remediating rule 19/76: 'accounts_are_necessary'")
(>&2 echo "FIX FOR THIS RULE 'accounts_are_necessary' IS MISSING!")

# END fix for 'accounts_are_necessary'

###############################################################################
# BEGIN fix (20 / 76) for 'group_unique_name'
###############################################################################
(>&2 echo "Remediating rule 20/76: 'group_unique_name'")
(>&2 echo "FIX FOR THIS RULE 'group_unique_name' IS MISSING!")

# END fix for 'group_unique_name'

###############################################################################
# BEGIN fix (21 / 76) for 'login_accounts_are_necessary'
###############################################################################
(>&2 echo "Remediating rule 21/76: 'login_accounts_are_necessary'")
(>&2 echo "FIX FOR THIS RULE 'login_accounts_are_necessary' IS MISSING!")

# END fix for 'login_accounts_are_necessary'

###############################################################################
# BEGIN fix (22 / 76) for 'account_unique_group_id'
###############################################################################
(>&2 echo "Remediating rule 22/76: 'account_unique_group_id'")
(>&2 echo "FIX FOR THIS RULE 'account_unique_group_id' IS MISSING!")

# END fix for 'account_unique_group_id'

###############################################################################
# BEGIN fix (23 / 76) for 'group_unique_id'
###############################################################################
(>&2 echo "Remediating rule 23/76: 'group_unique_id'")
(>&2 echo "FIX FOR THIS RULE 'group_unique_id' IS MISSING!")

# END fix for 'group_unique_id'

###############################################################################
# BEGIN fix (24 / 76) for 'account_unique_id'
###############################################################################
(>&2 echo "Remediating rule 24/76: 'account_unique_id'")
(>&2 echo "FIX FOR THIS RULE 'account_unique_id' IS MISSING!")

# END fix for 'account_unique_id'

###############################################################################
# BEGIN fix (25 / 76) for 'accounts_password_warn_age_login_defs'
###############################################################################
(>&2 echo "Remediating rule 25/76: 'accounts_password_warn_age_login_defs'")
(>&2 echo "FIX FOR THIS RULE 'accounts_password_warn_age_login_defs' IS MISSING!")

# END fix for 'accounts_password_warn_age_login_defs'

###############################################################################
# BEGIN fix (26 / 76) for 'accounts_minimum_age_login_defs'
###############################################################################
(>&2 echo "Remediating rule 26/76: 'accounts_minimum_age_login_defs'")
(>&2 echo "FIX FOR THIS RULE 'accounts_minimum_age_login_defs' IS MISSING!")

# END fix for 'accounts_minimum_age_login_defs'

###############################################################################
# BEGIN fix (27 / 76) for 'accounts_maximum_age_login_defs'
###############################################################################
(>&2 echo "Remediating rule 27/76: 'accounts_maximum_age_login_defs'")
(>&2 echo "FIX FOR THIS RULE 'accounts_maximum_age_login_defs' IS MISSING!")

# END fix for 'accounts_maximum_age_login_defs'

###############################################################################
# BEGIN fix (28 / 76) for 'accounts_no_uid_except_zero'
###############################################################################
(>&2 echo "Remediating rule 28/76: 'accounts_no_uid_except_zero'")
(>&2 echo "FIX FOR THIS RULE 'accounts_no_uid_except_zero' IS MISSING!")

# END fix for 'accounts_no_uid_except_zero'

###############################################################################
# BEGIN fix (29 / 76) for 'account_unique_name'
###############################################################################
(>&2 echo "Remediating rule 29/76: 'account_unique_name'")
(>&2 echo "FIX FOR THIS RULE 'account_unique_name' IS MISSING!")

# END fix for 'account_unique_name'

###############################################################################
# BEGIN fix (30 / 76) for 'gid_passwd_group_same'
###############################################################################
(>&2 echo "Remediating rule 30/76: 'gid_passwd_group_same'")
(>&2 echo "FIX FOR THIS RULE 'gid_passwd_group_same' IS MISSING!")

# END fix for 'gid_passwd_group_same'

###############################################################################
# BEGIN fix (31 / 76) for 'accounts_tmout'
###############################################################################
(>&2 echo "Remediating rule 31/76: 'accounts_tmout'")
(>&2 echo "FIX FOR THIS RULE 'accounts_tmout' IS MISSING!")

# END fix for 'accounts_tmout'

###############################################################################
# BEGIN fix (32 / 76) for 'accounts_user_interactive_home_directory_exists'
###############################################################################
(>&2 echo "Remediating rule 32/76: 'accounts_user_interactive_home_directory_exists'")
(>&2 echo "FIX FOR THIS RULE 'accounts_user_interactive_home_directory_exists' IS MISSING!")

# END fix for 'accounts_user_interactive_home_directory_exists'

###############################################################################
# BEGIN fix (33 / 76) for 'accounts_umask_etc_bashrc'
###############################################################################
(>&2 echo "Remediating rule 33/76: 'accounts_umask_etc_bashrc'")
(>&2 echo "FIX FOR THIS RULE 'accounts_umask_etc_bashrc' IS MISSING!")

# END fix for 'accounts_umask_etc_bashrc'

###############################################################################
# BEGIN fix (34 / 76) for 'require_singleuser_auth'
###############################################################################
(>&2 echo "Remediating rule 34/76: 'require_singleuser_auth'")
(>&2 echo "FIX FOR THIS RULE 'require_singleuser_auth' IS MISSING!")

# END fix for 'require_singleuser_auth'

###############################################################################
# BEGIN fix (35 / 76) for 'no_files_unowned_by_user'
###############################################################################
(>&2 echo "Remediating rule 35/76: 'no_files_unowned_by_user'")
(>&2 echo "FIX FOR THIS RULE 'no_files_unowned_by_user' IS MISSING!")

# END fix for 'no_files_unowned_by_user'

###############################################################################
# BEGIN fix (36 / 76) for 'no_empty_symlink_files'
###############################################################################
(>&2 echo "Remediating rule 36/76: 'no_empty_symlink_files'")
(>&2 echo "FIX FOR THIS RULE 'no_empty_symlink_files' IS MISSING!")

# END fix for 'no_empty_symlink_files'

###############################################################################
# BEGIN fix (37 / 76) for 'no_hide_exec_files'
###############################################################################
(>&2 echo "Remediating rule 37/76: 'no_hide_exec_files'")
(>&2 echo "FIX FOR THIS RULE 'no_hide_exec_files' IS MISSING!")

# END fix for 'no_hide_exec_files'

###############################################################################
# BEGIN fix (38 / 76) for 'dir_perms_world_writable_sticky_bits'
###############################################################################
(>&2 echo "Remediating rule 38/76: 'dir_perms_world_writable_sticky_bits'")
(>&2 echo "FIX FOR THIS RULE 'dir_perms_world_writable_sticky_bits' IS MISSING!")

# END fix for 'dir_perms_world_writable_sticky_bits'

###############################################################################
# BEGIN fix (39 / 76) for 'file_permissions_ungroupowned'
###############################################################################
(>&2 echo "Remediating rule 39/76: 'file_permissions_ungroupowned'")
(>&2 echo "FIX FOR THIS RULE 'file_permissions_ungroupowned' IS MISSING!")

# END fix for 'file_permissions_ungroupowned'

###############################################################################
# BEGIN fix (40 / 76) for 'file_groupowner_etc_gshadow'
###############################################################################
(>&2 echo "Remediating rule 40/76: 'file_groupowner_etc_gshadow'")


chgrp 0 /etc/gshadow

# END fix for 'file_groupowner_etc_gshadow'

###############################################################################
# BEGIN fix (41 / 76) for 'file_groupowner_etc_group'
###############################################################################
(>&2 echo "Remediating rule 41/76: 'file_groupowner_etc_group'")


chgrp 0 /etc/group

# END fix for 'file_groupowner_etc_group'

###############################################################################
# BEGIN fix (42 / 76) for 'file_permissions_etc_gshadow'
###############################################################################
(>&2 echo "Remediating rule 42/76: 'file_permissions_etc_gshadow'")

chmod 0000 /etc/gshadow

# END fix for 'file_permissions_etc_gshadow'

###############################################################################
# BEGIN fix (43 / 76) for 'file_owner_etc_group'
###############################################################################
(>&2 echo "Remediating rule 43/76: 'file_owner_etc_group'")


chown 0 /etc/group

# END fix for 'file_owner_etc_group'

###############################################################################
# BEGIN fix (44 / 76) for 'file_owner_etc_shadow'
###############################################################################
(>&2 echo "Remediating rule 44/76: 'file_owner_etc_shadow'")


chown 0 /etc/shadow

# END fix for 'file_owner_etc_shadow'

###############################################################################
# BEGIN fix (45 / 76) for 'file_owner_etc_passwd'
###############################################################################
(>&2 echo "Remediating rule 45/76: 'file_owner_etc_passwd'")


chown 0 /etc/passwd

# END fix for 'file_owner_etc_passwd'

###############################################################################
# BEGIN fix (46 / 76) for 'file_owner_etc_gshadow'
###############################################################################
(>&2 echo "Remediating rule 46/76: 'file_owner_etc_gshadow'")


chown 0 /etc/gshadow

# END fix for 'file_owner_etc_gshadow'

###############################################################################
# BEGIN fix (47 / 76) for 'file_permissions_etc_shadow'
###############################################################################
(>&2 echo "Remediating rule 47/76: 'file_permissions_etc_shadow'")

chmod 0000 /etc/shadow

# END fix for 'file_permissions_etc_shadow'

###############################################################################
# BEGIN fix (48 / 76) for 'file_groupowner_etc_shadow'
###############################################################################
(>&2 echo "Remediating rule 48/76: 'file_groupowner_etc_shadow'")


chgrp 0 /etc/shadow

# END fix for 'file_groupowner_etc_shadow'

###############################################################################
# BEGIN fix (49 / 76) for 'file_groupowner_etc_passwd'
###############################################################################
(>&2 echo "Remediating rule 49/76: 'file_groupowner_etc_passwd'")


chgrp 0 /etc/passwd

# END fix for 'file_groupowner_etc_passwd'

###############################################################################
# BEGIN fix (50 / 76) for 'file_permissions_etc_group'
###############################################################################
(>&2 echo "Remediating rule 50/76: 'file_permissions_etc_group'")

chmod 0644 /etc/group

# END fix for 'file_permissions_etc_group'

###############################################################################
# BEGIN fix (51 / 76) for 'file_permissions_etc_passwd'
###############################################################################
(>&2 echo "Remediating rule 51/76: 'file_permissions_etc_passwd'")

chmod 0644 /etc/passwd

# END fix for 'file_permissions_etc_passwd'

###############################################################################
# BEGIN fix (52 / 76) for 'sysctl_kernel_dmesg_restrict'
###############################################################################
(>&2 echo "Remediating rule 52/76: 'sysctl_kernel_dmesg_restrict'")
(>&2 echo "FIX FOR THIS RULE 'sysctl_kernel_dmesg_restrict' IS MISSING!")

# END fix for 'sysctl_kernel_dmesg_restrict'

###############################################################################
# BEGIN fix (53 / 76) for 'sysctl_kernel_randomize_va_space'
###############################################################################
(>&2 echo "Remediating rule 53/76: 'sysctl_kernel_randomize_va_space'")
(>&2 echo "FIX FOR THIS RULE 'sysctl_kernel_randomize_va_space' IS MISSING!")

# END fix for 'sysctl_kernel_randomize_va_space'

###############################################################################
# BEGIN fix (54 / 76) for 'sysctl_kernel_kptr_restrict'
###############################################################################
(>&2 echo "Remediating rule 54/76: 'sysctl_kernel_kptr_restrict'")
(>&2 echo "FIX FOR THIS RULE 'sysctl_kernel_kptr_restrict' IS MISSING!")

# END fix for 'sysctl_kernel_kptr_restrict'

###############################################################################
# BEGIN fix (55 / 76) for 'service_rsyslog_enabled'
###############################################################################
(>&2 echo "Remediating rule 55/76: 'service_rsyslog_enabled'")
(>&2 echo "FIX FOR THIS RULE 'service_rsyslog_enabled' IS MISSING!")

# END fix for 'service_rsyslog_enabled'

###############################################################################
# BEGIN fix (56 / 76) for 'configure_ssh_crypto_policy'
###############################################################################
(>&2 echo "Remediating rule 56/76: 'configure_ssh_crypto_policy'")
(>&2 echo "FIX FOR THIS RULE 'configure_ssh_crypto_policy' IS MISSING!")

# END fix for 'configure_ssh_crypto_policy'

###############################################################################
# BEGIN fix (57 / 76) for 'ensure_gpgcheck_never_disabled'
###############################################################################
(>&2 echo "Remediating rule 57/76: 'ensure_gpgcheck_never_disabled'")
(>&2 echo "FIX FOR THIS RULE 'ensure_gpgcheck_never_disabled' IS MISSING!")

# END fix for 'ensure_gpgcheck_never_disabled'

###############################################################################
# BEGIN fix (58 / 76) for 'package_python2_removed'
###############################################################################
(>&2 echo "Remediating rule 58/76: 'package_python2_removed'")

# CAUTION: This remediation script will remove python2
#	   from the system, and may remove any packages
#	   that depend on python2. Execute this
#	   remediation AFTER testing on a non-production
#	   system!

if rpm -q --quiet "python2" ; then
    dnf remove -y "python2"
fi

# END fix for 'package_python2_removed'

###############################################################################
# BEGIN fix (59 / 76) for 'service_auditd_enabled'
###############################################################################
(>&2 echo "Remediating rule 59/76: 'service_auditd_enabled'")
(>&2 echo "FIX FOR THIS RULE 'service_auditd_enabled' IS MISSING!")

# END fix for 'service_auditd_enabled'

###############################################################################
# BEGIN fix (60 / 76) for 'auditd_data_retention_num_logs'
###############################################################################
(>&2 echo "Remediating rule 60/76: 'auditd_data_retention_num_logs'")

var_auditd_num_logs="5"

AUDITCONFIG=/etc/audit/auditd.conf
# Function to replace configuration setting in config file or add the configuration setting if
# it does not exist.
#
# Expects arguments:
#
# config_file:		Configuration file that will be modified
# key:			Configuration option to change
# value:		Value of the configuration option to change
# cce:			The CCE identifier or '@CCENUM@' if no CCE identifier exists
# format:		The printf-like format string that will be given stripped key and value as arguments,
#			so e.g. '%s=%s' will result in key=value subsitution (i.e. without spaces around =)
#
# Optional arugments:
#
# format:		Optional argument to specify the format of how key/value should be
# 			modified/appended in the configuration file. The default is key = value.
#
# Example Call(s):
#
#     With default format of 'key = value':
#     replace_or_append '/etc/sysctl.conf' '^kernel.randomize_va_space' '2' '@CCENUM@'
#
#     With custom key/value format:
#     replace_or_append '/etc/sysconfig/selinux' '^SELINUX=' 'disabled' '@CCENUM@' '%s=%s'
#
#     With a variable:
#     replace_or_append '/etc/sysconfig/selinux' '^SELINUX=' $var_selinux_state '@CCENUM@' '%s=%s'
#
function replace_or_append {
  local default_format='%s = %s' case_insensitive_mode=yes sed_case_insensitive_option='' grep_case_insensitive_option=''
  local config_file=$1
  local key=$2
  local value=$3
  local cce=$4
  local format=$5

  if [ "$case_insensitive_mode" = yes ]; then
    sed_case_insensitive_option="i"
    grep_case_insensitive_option="-i"
  fi
  [ -n "$format" ] || format="$default_format"
  # Check sanity of the input
  [ $# -ge "3" ] || { echo "Usage: replace_or_append <config_file_location> <key_to_search> <new_value> [<CCE number or literal '@CCENUM@' if unknown>] [printf-like format, default is '$default_format']" >&2; exit 1; }

  # Test if the config_file is a symbolic link. If so, use --follow-symlinks with sed.
  # Otherwise, regular sed command will do.
  sed_command=('sed' '-i')
  if test -L "$config_file"; then
    sed_command+=('--follow-symlinks')
  fi

  # Test that the cce arg is not empty or does not equal @CCENUM@.
  # If @CCENUM@ exists, it means that there is no CCE assigned.
  if [ -n "$cce" ] && [ "$cce" != '@CCENUM@' ]; then
    cce="${cce}"
  else
    cce="CCE"
  fi

  # Strip any search characters in the key arg so that the key can be replaced without
  # adding any search characters to the config file.
  stripped_key=$(sed 's/[\^=\$,;+]*//g' <<< "$key")

  # shellcheck disable=SC2059
  printf -v formatted_output "$format" "$stripped_key" "$value"

  # If the key exists, change it. Otherwise, add it to the config_file.
  # We search for the key string followed by a word boundary (matched by \>),
  # so if we search for 'setting', 'setting2' won't match.
  if LC_ALL=C grep -q -m 1 $grep_case_insensitive_option -e "${key}\\>" "$config_file"; then
    "${sed_command[@]}" "s/${key}\\>.*/$formatted_output/g$sed_case_insensitive_option" "$config_file"
  else
    # \n is precaution for case where file ends without trailing newline
    printf '\n# Per %s: Set %s in %s\n' "$cce" "$formatted_output" "$config_file" >> "$config_file"
    printf '%s\n' "$formatted_output" >> "$config_file"
  fi
}
replace_or_append $AUDITCONFIG '^num_logs' "$var_auditd_num_logs" "@CCENUM@"

# END fix for 'auditd_data_retention_num_logs'

###############################################################################
# BEGIN fix (61 / 76) for 'auditd_data_retention_max_log_file_action'
###############################################################################
(>&2 echo "Remediating rule 61/76: 'auditd_data_retention_max_log_file_action'")
(>&2 echo "FIX FOR THIS RULE 'auditd_data_retention_max_log_file_action' IS MISSING!")

# END fix for 'auditd_data_retention_max_log_file_action'

###############################################################################
# BEGIN fix (62 / 76) for 'package_ftp_removed'
###############################################################################
(>&2 echo "Remediating rule 62/76: 'package_ftp_removed'")

# CAUTION: This remediation script will remove ftp
#	   from the system, and may remove any packages
#	   that depend on ftp. Execute this
#	   remediation AFTER testing on a non-production
#	   system!

if rpm -q --quiet "ftp" ; then
    dnf remove -y "ftp"
fi

# END fix for 'package_ftp_removed'

###############################################################################
# BEGIN fix (63 / 76) for 'no_lowprivilege_users_writeable_cmds_in_crontab_file'
###############################################################################
(>&2 echo "Remediating rule 63/76: 'no_lowprivilege_users_writeable_cmds_in_crontab_file'")
(>&2 echo "FIX FOR THIS RULE 'no_lowprivilege_users_writeable_cmds_in_crontab_file' IS MISSING!")

# END fix for 'no_lowprivilege_users_writeable_cmds_in_crontab_file'

###############################################################################
# BEGIN fix (64 / 76) for 'package_tftp_removed'
###############################################################################
(>&2 echo "Remediating rule 64/76: 'package_tftp_removed'")

# CAUTION: This remediation script will remove tftp
#	   from the system, and may remove any packages
#	   that depend on tftp. Execute this
#	   remediation AFTER testing on a non-production
#	   system!

if rpm -q --quiet "tftp" ; then
    dnf remove -y "tftp"
fi

# END fix for 'package_tftp_removed'

###############################################################################
# BEGIN fix (65 / 76) for 'package_tftp-server_removed'
###############################################################################
(>&2 echo "Remediating rule 65/76: 'package_tftp-server_removed'")

# CAUTION: This remediation script will remove tftp-server
#	   from the system, and may remove any packages
#	   that depend on tftp-server. Execute this
#	   remediation AFTER testing on a non-production
#	   system!

if rpm -q --quiet "tftp-server" ; then
    dnf remove -y "tftp-server"
fi

# END fix for 'package_tftp-server_removed'

###############################################################################
# BEGIN fix (66 / 76) for 'package_telnet_removed'
###############################################################################
(>&2 echo "Remediating rule 66/76: 'package_telnet_removed'")

# CAUTION: This remediation script will remove telnet
#	   from the system, and may remove any packages
#	   that depend on telnet. Execute this
#	   remediation AFTER testing on a non-production
#	   system!

if rpm -q --quiet "telnet" ; then
    dnf remove -y "telnet"
fi

# END fix for 'package_telnet_removed'

###############################################################################
# BEGIN fix (67 / 76) for 'package_net-snmp_removed'
###############################################################################
(>&2 echo "Remediating rule 67/76: 'package_net-snmp_removed'")

# CAUTION: This remediation script will remove net-snmp
#	   from the system, and may remove any packages
#	   that depend on net-snmp. Execute this
#	   remediation AFTER testing on a non-production
#	   system!

if rpm -q --quiet "net-snmp" ; then
    dnf remove -y "net-snmp"
fi

# END fix for 'package_net-snmp_removed'

###############################################################################
# BEGIN fix (68 / 76) for 'sshd_use_strong_pubkey'
###############################################################################
(>&2 echo "Remediating rule 68/76: 'sshd_use_strong_pubkey'")
(>&2 echo "FIX FOR THIS RULE 'sshd_use_strong_pubkey' IS MISSING!")

# END fix for 'sshd_use_strong_pubkey'

###############################################################################
# BEGIN fix (69 / 76) for 'sshd_enable_pam'
###############################################################################
(>&2 echo "Remediating rule 69/76: 'sshd_enable_pam'")
if [ -e "/etc/ssh/sshd_config" ] ; then
    LC_ALL=C sed -i "/^\s*UsePAM\s\+/Id" "/etc/ssh/sshd_config"
else
    touch "/etc/ssh/sshd_config"
fi
cp "/etc/ssh/sshd_config" "/etc/ssh/sshd_config.bak"
# Insert before the line matching the regex '^Match'.
line_number="$(LC_ALL=C grep -n "^Match" "/etc/ssh/sshd_config.bak" | LC_ALL=C sed 's/:.*//g')"
if [ -z "$line_number" ]; then
    # There was no match of '^Match', insert at
    # the end of the file.
    printf '%s\n' "UsePAM yes" >> "/etc/ssh/sshd_config"
else
    head -n "$(( line_number - 1 ))" "/etc/ssh/sshd_config.bak" > "/etc/ssh/sshd_config"
    printf '%s\n' "UsePAM yes" >> "/etc/ssh/sshd_config"
    tail -n "+$(( line_number ))" "/etc/ssh/sshd_config.bak" >> "/etc/ssh/sshd_config"
fi
# Clean up after ourselves.
rm "/etc/ssh/sshd_config.bak"

# END fix for 'sshd_enable_pam'

###############################################################################
# BEGIN fix (70 / 76) for 'sshd_allow_only_protocol2'
###############################################################################
(>&2 echo "Remediating rule 70/76: 'sshd_allow_only_protocol2'")
if [ -e "/etc/ssh/sshd_config" ] ; then
    LC_ALL=C sed -i "/^\s*Protocol\s\+/Id" "/etc/ssh/sshd_config"
else
    touch "/etc/ssh/sshd_config"
fi
cp "/etc/ssh/sshd_config" "/etc/ssh/sshd_config.bak"
# Insert before the line matching the regex '^Match'.
line_number="$(LC_ALL=C grep -n "^Match" "/etc/ssh/sshd_config.bak" | LC_ALL=C sed 's/:.*//g')"
if [ -z "$line_number" ]; then
    # There was no match of '^Match', insert at
    # the end of the file.
    printf '%s\n' "Protocol 2" >> "/etc/ssh/sshd_config"
else
    head -n "$(( line_number - 1 ))" "/etc/ssh/sshd_config.bak" > "/etc/ssh/sshd_config"
    printf '%s\n' "Protocol 2" >> "/etc/ssh/sshd_config"
    tail -n "+$(( line_number ))" "/etc/ssh/sshd_config.bak" >> "/etc/ssh/sshd_config"
fi
# Clean up after ourselves.
rm "/etc/ssh/sshd_config.bak"

# END fix for 'sshd_allow_only_protocol2'

###############################################################################
# BEGIN fix (71 / 76) for 'disable_host_auth'
###############################################################################
(>&2 echo "Remediating rule 71/76: 'disable_host_auth'")
if [ -e "/etc/ssh/sshd_config" ] ; then
    LC_ALL=C sed -i "/^\s*HostbasedAuthentication\s\+/Id" "/etc/ssh/sshd_config"
else
    touch "/etc/ssh/sshd_config"
fi
cp "/etc/ssh/sshd_config" "/etc/ssh/sshd_config.bak"
# Insert before the line matching the regex '^Match'.
line_number="$(LC_ALL=C grep -n "^Match" "/etc/ssh/sshd_config.bak" | LC_ALL=C sed 's/:.*//g')"
if [ -z "$line_number" ]; then
    # There was no match of '^Match', insert at
    # the end of the file.
    printf '%s\n' "HostbasedAuthentication no" >> "/etc/ssh/sshd_config"
else
    head -n "$(( line_number - 1 ))" "/etc/ssh/sshd_config.bak" > "/etc/ssh/sshd_config"
    printf '%s\n' "HostbasedAuthentication no" >> "/etc/ssh/sshd_config"
    tail -n "+$(( line_number ))" "/etc/ssh/sshd_config.bak" >> "/etc/ssh/sshd_config"
fi
# Clean up after ourselves.
rm "/etc/ssh/sshd_config.bak"

# END fix for 'disable_host_auth'

###############################################################################
# BEGIN fix (72 / 76) for 'sshd_use_strong_kex'
###############################################################################
(>&2 echo "Remediating rule 72/76: 'sshd_use_strong_kex'")
(>&2 echo "FIX FOR THIS RULE 'sshd_use_strong_kex' IS MISSING!")

# END fix for 'sshd_use_strong_kex'

###############################################################################
# BEGIN fix (73 / 76) for 'sshd_use_strong_ciphers'
###############################################################################
(>&2 echo "Remediating rule 73/76: 'sshd_use_strong_ciphers'")

if [ -e "/etc/ssh/sshd_config" ] ; then
    LC_ALL=C sed -i "/^\s*Ciphers\s\+/Id" "/etc/ssh/sshd_config"
else
    touch "/etc/ssh/sshd_config"
fi
cp "/etc/ssh/sshd_config" "/etc/ssh/sshd_config.bak"
# Insert before the line matching the regex '^Match'.
line_number="$(LC_ALL=C grep -n "^Match" "/etc/ssh/sshd_config.bak" | LC_ALL=C sed 's/:.*//g')"
if [ -z "$line_number" ]; then
    # There was no match of '^Match', insert at
    # the end of the file.
    printf '%s\n' "Ciphers aes128-ctr,aes192-ctr,aes256-ctr,chacha20-poly1305@openssh.com,aes256-gcm@openssh.com,aes128-gcm@openssh.com" >> "/etc/ssh/sshd_config"
else
    head -n "$(( line_number - 1 ))" "/etc/ssh/sshd_config.bak" > "/etc/ssh/sshd_config"
    printf '%s\n' "Ciphers aes128-ctr,aes192-ctr,aes256-ctr,chacha20-poly1305@openssh.com,aes256-gcm@openssh.com,aes128-gcm@openssh.com" >> "/etc/ssh/sshd_config"
    tail -n "+$(( line_number ))" "/etc/ssh/sshd_config.bak" >> "/etc/ssh/sshd_config"
fi
# Clean up after ourselves.
rm "/etc/ssh/sshd_config.bak"

# END fix for 'sshd_use_strong_ciphers'

###############################################################################
# BEGIN fix (74 / 76) for 'sshd_disable_empty_passwords'
###############################################################################
(>&2 echo "Remediating rule 74/76: 'sshd_disable_empty_passwords'")
if [ -e "/etc/ssh/sshd_config" ] ; then
    LC_ALL=C sed -i "/^\s*PermitEmptyPasswords\s\+/Id" "/etc/ssh/sshd_config"
else
    touch "/etc/ssh/sshd_config"
fi
cp "/etc/ssh/sshd_config" "/etc/ssh/sshd_config.bak"
# Insert before the line matching the regex '^Match'.
line_number="$(LC_ALL=C grep -n "^Match" "/etc/ssh/sshd_config.bak" | LC_ALL=C sed 's/:.*//g')"
if [ -z "$line_number" ]; then
    # There was no match of '^Match', insert at
    # the end of the file.
    printf '%s\n' "PermitEmptyPasswords no" >> "/etc/ssh/sshd_config"
else
    head -n "$(( line_number - 1 ))" "/etc/ssh/sshd_config.bak" > "/etc/ssh/sshd_config"
    printf '%s\n' "PermitEmptyPasswords no" >> "/etc/ssh/sshd_config"
    tail -n "+$(( line_number ))" "/etc/ssh/sshd_config.bak" >> "/etc/ssh/sshd_config"
fi
# Clean up after ourselves.
rm "/etc/ssh/sshd_config.bak"

# END fix for 'sshd_disable_empty_passwords'

###############################################################################
# BEGIN fix (75 / 76) for 'sshd_disable_rhosts'
###############################################################################
(>&2 echo "Remediating rule 75/76: 'sshd_disable_rhosts'")
if [ -e "/etc/ssh/sshd_config" ] ; then
    LC_ALL=C sed -i "/^\s*IgnoreRhosts\s\+/Id" "/etc/ssh/sshd_config"
else
    touch "/etc/ssh/sshd_config"
fi
cp "/etc/ssh/sshd_config" "/etc/ssh/sshd_config.bak"
# Insert before the line matching the regex '^Match'.
line_number="$(LC_ALL=C grep -n "^Match" "/etc/ssh/sshd_config.bak" | LC_ALL=C sed 's/:.*//g')"
if [ -z "$line_number" ]; then
    # There was no match of '^Match', insert at
    # the end of the file.
    printf '%s\n' "IgnoreRhosts yes" >> "/etc/ssh/sshd_config"
else
    head -n "$(( line_number - 1 ))" "/etc/ssh/sshd_config.bak" > "/etc/ssh/sshd_config"
    printf '%s\n' "IgnoreRhosts yes" >> "/etc/ssh/sshd_config"
    tail -n "+$(( line_number ))" "/etc/ssh/sshd_config.bak" >> "/etc/ssh/sshd_config"
fi
# Clean up after ourselves.
rm "/etc/ssh/sshd_config.bak"

# END fix for 'sshd_disable_rhosts'

###############################################################################
# BEGIN fix (76 / 76) for 'sshd_use_strong_macs'
###############################################################################
(>&2 echo "Remediating rule 76/76: 'sshd_use_strong_macs'")

if [ -e "/etc/ssh/sshd_config" ] ; then
    LC_ALL=C sed -i "/^\s*MACs\s\+/Id" "/etc/ssh/sshd_config"
else
    touch "/etc/ssh/sshd_config"
fi
cp "/etc/ssh/sshd_config" "/etc/ssh/sshd_config.bak"
# Insert before the line matching the regex '^Match'.
line_number="$(LC_ALL=C grep -n "^Match" "/etc/ssh/sshd_config.bak" | LC_ALL=C sed 's/:.*//g')"
if [ -z "$line_number" ]; then
    # There was no match of '^Match', insert at
    # the end of the file.
    printf '%s\n' "MACs hmac-sha2-512-etm@openssh.com,hmac-sha2-256-etm@openssh.com,umac-128-etm@openssh.com,hmac-sha2-512,hmac-sha2-256,hmac-ripemd160" >> "/etc/ssh/sshd_config"
else
    head -n "$(( line_number - 1 ))" "/etc/ssh/sshd_config.bak" > "/etc/ssh/sshd_config"
    printf '%s\n' "MACs hmac-sha2-512-etm@openssh.com,hmac-sha2-256-etm@openssh.com,umac-128-etm@openssh.com,hmac-sha2-512,hmac-sha2-256,hmac-ripemd160" >> "/etc/ssh/sshd_config"
    tail -n "+$(( line_number ))" "/etc/ssh/sshd_config.bak" >> "/etc/ssh/sshd_config"
fi
# Clean up after ourselves.
rm "/etc/ssh/sshd_config.bak"

# END fix for 'sshd_use_strong_macs'

